package org.dromara.common.core.utils;


import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * 经纬度距离计算工具类
 *
 * @author ym
 */
public class DistanceUtils {

    /**
     * 地球半径：6378137m
     */
    private static final double EARTH_RADIUS = 6378137;


    private static double rad(double d) {
        return d * Math.PI / 180.0;
    }

    /**
     * 计算两点间的距离
     *
     * @param lat1 起点纬度
     * @param lng1 起点经度
     * @param lat2 终点纬度
     * @param lng2 终点经度
     * @return 距离（单位：米）
     */
    public static double calcDistance(double lat1, double lng1, double lat2, double lng2) {
        double radLat1 = lat1 * Math.PI / 180.0;
        double radLat2 = lat2 * Math.PI / 180.0;
        double a = radLat1 - radLat2;
        double b = lng1 * Math.PI / 180.0 - lng2 * Math.PI / 180.0;

        double s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2)
            + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
        s = s * EARTH_RADIUS;
        s = Math.round(s * 10000d) / 10000d;
        return s;
    }


    /**
     * 计算两点间的距离
     *
     * @param lat1 起点纬度
     * @param lng1 起点经度
     * @param lat2 终点纬度
     * @param lng2 终点经度
     * @return 距离（单位：米）
     */
    public static BigDecimal calcDistance(BigDecimal lat1, BigDecimal lng1, BigDecimal lat2, BigDecimal lng2) {
        double distance = calcDistance(lat1.doubleValue(), lng1.doubleValue(), lat2.doubleValue(), lng2.doubleValue());
        // 保留小数点后两位
        return new BigDecimal(String.valueOf(distance)).setScale(2, RoundingMode.HALF_UP);
    }

}
